package snow;

public class SWConstants
{
  static final int INIT_WIDTH = 8;  // Initial width of Grid City in blocks.
  static final int INIT_HEIGHT = 10;  // Initial height of Grid City in blocks.
  static final boolean INIT_CORNERS = true;
  static final boolean INIT_WALKTHROUGH = true;
  static final int MIN_DIM = 0;
  static final int MAX_DIM = 20;
  static final int INIT_PLOWS = 1;
  static final int MIN_PLOWS = 0;
  static final int MAX_PLOWS = 99;
  static final int INIT_LENGTH = 0;
  static final int MIN_LENGTH = 0;
  static final int MAX_LENGTH = 99;
  static final boolean INIT_BOUNDARY_ONLY = true;
  static final boolean INIT_ALLOW_RETRACE = false;
  static final int PLOW_MINUTES = 20;
  
  static final String START_PLOW_STRING = "<";
  static final String END_PLOW_STRING = ">";
  static final int SCRIPT_WORD_WRAP = 20;

  // Distance between adjacent intersections.
  static final double I_TO_I_COST = 1.0;
  // Distance from a corner entrance to its intersection.
  // Also distance from an edge entrance to the middle of the street.
  static final double E_TO_I_COST = 0;
  // Default cost between entrances on the same block.
  static final double DEFAULT_COST = 1;
  
  static final int NIL = -1;

  public enum Type
  {
    INTERSECTION,
    ENTRANCE
  }

  static final int CORNER_ADJACENT = 0;
  static final int CORNER_OPPOSITE = 1;
  static final int SIDE_ADJACENT = 2;
  static final int SIDE_OPPOSITE = 3;
  static final int COSTS = 4;
  
  // Directions go clockwise from N or NW.
  static final int N = 0;
  static final int NW = 0;
  static final int E = 1;
  static final int NE = 1;
  static final int S = 2;
  static final int SE = 2;
  static final int W = 3;
  static final int SW = 3;
  static final int DIRS = 4;
}
