package snow;

import java.util.*;
import static snow.SWConstants.*;

class Vertex
{
  static final String[] CORNERLABELS =
  {
    "NW",
    "NE",
    "SE",
    "SW",
  };
  
  static final String[] EDGELABELS =
  {
    "N",
    "E",
    "S",
    "W",
  };  
  
	int id;
	Type type;
	int vx;
	int vy;
	int dir;
	boolean corner;
	ArrayList<Vertex> edges = new ArrayList<Vertex>();
	ArrayList<Double> weights = new ArrayList<Double>();
	
	Vertex(int _id, Type _type, int _vx, int _vy, int _dir, boolean _corner)
	{
		id = _id;
		type = _type;
		vx = _vx;
		vy = _vy;
		dir = _dir;
		corner = _corner;
	}
	
	void addEdge(Vertex v, double weight)
	{
		edges.add(v);
		weights.add(weight);  			
	}
	
	public String toString()
	{
	  String t = type == Type.INTERSECTION ? "I" : "E";
	  String coord = "(" + vx + "," + vy + ")";
	  String d = dir == NIL ? "" : corner ? CORNERLABELS[dir] : EDGELABELS[dir];
	  return t + coord + d;
	}
}
